# Understanding Git: Plumbing and Porcelain

Version control systems are regarded as essential tools for writing code. Whether you're working alone or in a team, on small or large projects, version control is an invaluable tool for tracking code changes. Git is, arguably, the most popular and perhaps the most important version control system, especially in the open source world.

While learning to use Git is important and most useful aspects of Git can be leveraged by basic workflows, understanding how Git works can help unlock its true power and avoid many pitfalls that come with more complicated workflows.

In this 90-minute talk, I hope to demystify the most important aspects of Git's internals. We will begin by going through the simple internal structures that Git uses to track changes and follow with an explanation of how these internal components are used to build the basic Git functions that we all use. Finally, we will review some basic, high-level Git workflows, from a lower-level perspective.

Note: No experience or knowledge of Git is assumed for this talk.

## Presentation slides

Slides are written in markdown and were presented using [reveal-md](http://webpro.github.io/reveal-md/)
```bash
reveal-md slides.md
```
